/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 18.06.2006                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


//From left to right: 3-2-1-0
/////////////////////////////

#define VERSION_DIGIT_3		0
#define VERSION_DIGIT_2		2
#define VERSION_DIGIT_1		2
#define VERSION_DIGIT_0		0



//used in "codec_vfw.h"
///////////////////////

#define STRINGIZY(x) #x
#define WSTRINGIZY(x) L#x

#define VERSION_VFW_3DIGITS(x2,x1,x0)  WSTRINGIZY(x2) L"." WSTRINGIZY(x1) L"." WSTRINGIZY(x0)

#define VERSION_VFW   VERSION_VFW_3DIGITS(VERSION_DIGIT_3, VERSION_DIGIT_2, VERSION_DIGIT_1)


// used in "resource.rc"
////////////////////////

#define VERSION_STR_RC_4DIGITS(x3,x2,x1,x0)   WSTRINGIZY(x3) L", " WSTRINGIZY(x2) L", " WSTRINGIZY(x1) L", " WSTRINGIZY(x0) L"\0"

#define VERSION_RC   VERSION_DIGIT_3, VERSION_DIGIT_2, VERSION_DIGIT_1, VERSION_DIGIT_0
#define VERSION_STR_RC   VERSION_STR_RC_4DIGITS(VERSION_DIGIT_3, VERSION_DIGIT_2, VERSION_DIGIT_1, VERSION_DIGIT_0)

#define FILEVERSION_RC VERSION_RC
#define PRODUCTVERSION_RC VERSION_RC
#define FILEVERSION_STR_RC VERSION_STR_RC
#define PRODUCTVERSION_STR_RC VERSION_STR_RC
#define FILENAME_STR_RC L"cedocida.dll\0"
